#include "stdafx.h"
#include "NScreenshot.h"


// 
CNScreenshot::CNScreenshot()
{
	//   gdi+
	GdiplusStartup(&gdipToken, &gdipStartupInput, NULL);
}

// 
CNScreenshot::~CNScreenshot()
{
	//   gdi+
	GdiplusShutdown(gdipToken);
}

//  
int CNScreenshot::GetEncoderClsid( const WCHAR *wcMimeType, CLSID* pClsid )
{
	//   
	UINT num = 0;
	//   ImageCodecInfo
	UINT size = 0;

	//    	
	ImageCodecInfo* pImageCodecInfo = NULL;

	//    
	GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1;  // Failure

	//    
	pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1;  // Failure

	//    
	GetImageEncoders(num, size, pImageCodecInfo);

	for( UINT i = 0; i < num; ++i )
	{
		if( wcscmp(pImageCodecInfo[i].MimeType, wcMimeType) == 0 )
		{
			*pClsid = pImageCodecInfo[i].Clsid;
			free(pImageCodecInfo);
			return i;  // Success
		}    
	}

	free(pImageCodecInfo);
	return 0;

}


//   
BOOLEAN CNScreenshot::TakeScreenshot( LPVOID *pJpegBuffer, PSIZE_T pJpegSize, ULONG ulQuality, const WCHAR *wcMimeType )
{
	BOOLEAN bRet =TRUE;

	HDC hDesktopDC, hMemDC;
	HBITMAP hMemBitmap;
	//  HDC  
	hDesktopDC = ::GetDC(NULL);

	UINT uiHeight = GetDeviceCaps( hDesktopDC, VERTRES ); //GetSystemMetrics( SM_CYSCREEN );
	UINT uiWidth = GetDeviceCaps( hDesktopDC, HORZRES ); //GetSystemMetrics( SM_CXSCREEN );
	hMemDC = CreateCompatibleDC( hDesktopDC );
	hMemBitmap = CreateCompatibleBitmap( hDesktopDC, uiWidth, uiHeight);
	HBITMAP hOldBitmap =(HBITMAP)SelectObject( hMemDC, hMemBitmap );
	BitBlt( hMemDC, 0, 0, uiWidth, uiHeight, hDesktopDC, 0, 0, SRCCOPY );

	Gdiplus::Bitmap bitmap( hMemBitmap, NULL );

	CLSID encoderClsid;
	EncoderParameters encoderParam;

	//   
	//    0  100
	encoderParam.Count = 1;
	encoderParam.Parameter[0].Guid = EncoderQuality;
	encoderParam.Parameter[0].Type = EncoderParameterValueTypeLong;
	encoderParam.Parameter[0].NumberOfValues = 1;
	//
	encoderParam.Parameter[0].Value = &ulQuality;

	//  clsid 
	GetEncoderClsid( wcMimeType, &encoderClsid );


	IStream * pStream;
	if( SUCCEEDED( CreateStreamOnHGlobal(0,TRUE,&pStream ) ) ) // creating stream
	{
		//status = SrcBitmap.Save(pStream,&jpgClsid,0); // saving image to the stream
		if( ( bitmap.Save( pStream, &encoderClsid, &encoderParam ) ) ==Gdiplus::Ok )
		{
			LARGE_INTEGER lOfs;
			ULARGE_INTEGER lSize;
			
			lOfs.QuadPart = 0;
			if( SUCCEEDED( pStream->Seek( lOfs, STREAM_SEEK_END, &lSize ) ) ) // retrieving size of stream data (seek to end)
			{
				lOfs.QuadPart = 0;
				if( SUCCEEDED( pStream->Seek( lOfs, STREAM_SEEK_SET, 0 ) ) ) // seeking to beginning of the stream data
				{
					*pJpegSize = (ULONG)((DWORD_PTR)lSize.QuadPart);
					*pJpegBuffer = malloc( *pJpegSize ); // allocating userbuffer
					if( *pJpegBuffer )
					{
						if( SUCCEEDED( pStream->Read( *pJpegBuffer, (ULONG)*pJpegSize, 0 ) ) ) // reading stream to buffer
						{
							bRet =TRUE;
						}
					}
				}
			}
		}

		pStream->Release(); // releasing stream
	}

	SelectObject( hMemDC, hOldBitmap );
	DeleteObject( hMemDC );
	DeleteObject( hMemBitmap );
	::ReleaseDC( 0, hDesktopDC );

	return bRet;
}
